

/***************************************************************************
*
*        Programm:   Sim
*        Modul:      sim.h
*        Funktion:   headerfile
*
*        Datum:            10.07.88
*        letzte nderung:  05.05.89
*
***************************************************************************/

#include <exec/types.h>

struct liste
{
   struct liste *next;       /* Zeiger auf Liste weiterer Folgebausteine */
   struct device  *device;   /* Zeiger auf Struktur der Folgebausteine */
};


struct leitung
{
   char             *name;   /* Zeiger auf Namen der Variablen */
   USHORT           new;     /* aktueller Wert der Leitung */
   USHORT           old;     /* alter Wert der Leitung */
   struct liste     *liste;  /* Zeiger auf Liste der angeschlossenen
                                Bausteine */
   struct leitung   *next;   /* Zeiger auf nchste Leitung */
   USHORT           init;    /* Initialisierungswert der Leitung */
};


struct device
{
   void           (*device)();    /* Bausteinfunktion */
   struct device  *next;          /* Zeiger auf nchsten Baustein */
   struct device  *succ;          /* Zeiger auf nchsten Baustein
                                     in ready-queue */
   USHORT         out_count;      /* Anzahl der Ausgnge */
   struct leitung **out;          /* Zeiger auf Zeiger-Array auf Ausgnge */
   USHORT         in_count;       /* Anzahl der Eingnge */
   struct leitung **in;           /* Zeiger auf Zeiger-Array auf Eingnge */
   USHORT         *in_puffer;     /* Zeiger auf Array mit Eingangspuffer-
                                     daten */
   int            wait;           /* 0:Baustein ist bereit; 1:Bst. wartet */
   char           *file;          /* Data-File */
   void           (*dev_init)();  /* Baustein-Initialisierungsfunktion */
   USHORT         *state;         /* Zeiger auf Array mit Zustandswerten */
   USHORT         state_count;    /* Anzahl der Zustandswerte */
};


